:- use_module(cosldmeta2annotated).

coinductive(invoke(_,_,_,n)).
coinductive(has_meth(_,_,_,_)).
coinductive(with_meth(_,_,_,_,_)).

dec_fields(C,L) :- bagof(F,dec_field(C,F),L),!.
dec_fields(_,[]).

merge([],VL,[],VL).
merge([F|FL],[V|VL],[(F,V)|FVL],LVL) :- merge(FL,VL,FVL,LVL).

new(object,[],obj(object,[])).
new(C,Args,obj(C,FVL)) :- dec_fields(C,FL),merge(FL,Args,CFVL,PArgs),extends(C,P),new(P,PArgs,obj(P,PFVL)),append(CFVL,PFVL,FVL).

%field_acc(obj(_,FVL),F,V) :- member((F,V),FVL).
field_acc(TO,F,V) :- nonvar(TO),TO=obj(_,FVL),member((F,V),FVL).
field_acc(TO,F,_) :- var(TO),throw(error(instantiation_error,context(F,field_acc/3))).
field_acc(TO,F,_) :- TO\=obj(_,_),throw(error(type_error(object,TO),context(F,field_acc/3))).

%invoke(TO,M,Args,RV) :- TO=obj(C,_),has_meth(C,M,[TO|Args],RV). 
invoke(TO,M,Args,RV) :- nonvar(TO),TO=obj(C,_),has_meth(C,M,[TO|Args],RV).
invoke(TO,M,Args,_) :- var(TO),length(Args,N),throw(error(instantiation_error,context(M/N,invoke/4))).
invoke(TO,M,Args,_) :- TO\=obj(_,_),length(Args,N),throw(error(type_error(object,TO),context(M/N,invoke/4))).


finally(invoke(TO,M,Args,RV),invoke(_,_,_,Res)) :- TO=obj(C,_),with_meth(C,M,[TO|Args],Res,RV). 


%%% TODO: la modifica apportata alle clausole invoke e field_acc potrebbe servire anche per eq, neq, get, pos, add

eq(X,Y,true) :- X==Y,!.
eq(_,_,false).

neq(X,Y,false) :- X==Y,!.
neq(_,_,true).

lth(X,Y,true) :- X<Y,!.
lth(_,_,false).

gth(X,Y,true) :- X>Y,!.
gth(_,_,false).

leq(X,Y,true) :- X=<Y,!.
leq(_,_,false).

geq(X,Y,true) :- X>=Y,!.
geq(_,_,false).

and(X,Y,true) :- X,Y,!.
and(_,_,false).

or(X,Y,true) :- (X;Y),!.
or(_,_,false).

not(X,true) :- \+X,!.
not(_,false).

neg(X,-X).

sum(X,Y,R) :- R is X+Y.

dif(X,Y,R) :- R is X-Y.

prd(X,Y,R) :- R is X*Y.

div(X,Y,R) :- R is X/Y.

get(L,I,R) :- nth0(I,L,R).
get(_L,_I,null).

pos(L,E,R) :- nth0(R,L,E),!.
pos(_L,_E,null).

add(E,L,[E|L]).