:- module(cosldmeta2annotated,[cosld/1]).

%%% start meta-interpreter

cosld(G) :- solve([],G).
solve(H, (G1,G2)) :- !,solve(H, G1), solve(H,G2).
solve(_,A) :- inductive(A),!,A.
solve(H,A):- clause(A,As),(subsumed(A,H,MA)->applycoind(H,A,MA);(found(A,H,MA),applycoind(H,A,MA);insert(H,A,NewH),solve(NewH,As))).

applycoind(H,A,MA) :- clause(finally(A,MA),As) *-> solve(H,As);true.

inductive(A) :- predicate_property(A,built_in),!.
inductive(A) :- predicate_property(A,file(AbsPath)),
             file_name_on_path(AbsPath,library(_)),!.
inductive(A) :- \+ coinductive(A,_).

insert(L1,A,[A|L1]).

%found(A,H) :- memberchk(A,H).
found(A,L,MA) :- filtered(A,FA),found_unif(FA,L,MA).

%subsumed(A,[B|_]) :- subsumes(B,A),!.
%subsumed(A,[_|L]) :- subsumed(A,L).

subsumed(A,L,MA) :- filtered(A,FA), found_subs(FA,L,MA).

found_subs(A1,[A2|_],A2) :- filtered(A2,FA2),subsumes(FA2,A1),!.
found_subs(A,[_|L],MA) :- found_subs(A,L,MA).

found_unif(A1,[A2|_],A2) :- filtered(A2,FA2),A1=FA2,!.
found_unif(A,[_|L],MA) :- found_unif(A,L,MA).

coinductive(A1,A2) :- !,functor(A1,N,A), functor(A2,N,A), coinductive(A2).

filtered(T1,T2) :- !,coinductive(T1,AnnT1), T1 =.. L1, AnnT1 =.. AnnL1, combine(L1, AnnL1, L2), T2 =.. L2.

combine([F|Args1],[F|Anns],[F,N|Args2]) :- combine_args(Args1,Anns,Args2), length(Args1,N).

combine_args([],[],[]) :- !.
combine_args([Arg1|Args1],[Ann|Anns],Args) :- (Ann == n -> Args = Args2; Args = [Arg1|Args2]), combine_args(Args1,Anns,Args2).


%%% end meta-interpreter
